View a markdown version of this page

CreateCapacityProvider - Amazon Bedrock AgentCore Control Plane

CreateCapacityProvider

Creates a capacity provider. A capacity provider defines the Amazon EC2 infrastructure for AgentCore Runtime, including the operating system, allowed instance types, networking, and storage. You provide the IAM role that AgentCore uses to launch and manage the instances.

The capacity provider name must be unique within your account. After you create the capacity provider, it enters a CREATING state and transitions to READY when it is available for use.

Request Syntax

PUT /capacity-providers HTTP/1.1 Content-type: application/json { "clientToken": "string", "computeConfiguration": { ... }, "description": "string", "name": "string", "permissionsConfiguration": { "capacityProviderOperatorRoleArn": "string" }, "tags": { "string" : "string" } }

URI Request Parameters

The request does not use any URI parameters.

Request Body

The request accepts the following data in JSON format.

clientToken

A unique, case-sensitive identifier to ensure that the API request completes no more than one time. If you don't specify this field, a value is randomly generated for you. If this token matches a previous request, the service ignores the request, but doesn't return an error. For more information, see Ensuring idempotency.

Type: String

Length Constraints: Minimum length of 33. Maximum length of 256.

Pattern: [a-zA-Z0-9](-*[a-zA-Z0-9]){0,256}

Required: No

computeConfiguration

The compute configuration for the capacity provider. This defines the Amazon EC2 compute resources used to launch instances: the operating system, allowed instance types, networking, and storage.

Type: ComputeConfiguration object

Note: This object is a Union. Only one member of this object can be specified or returned.

Required: Yes

description

An optional description of the capacity provider. If you do not specify a description, the service creates the capacity provider without one.

Type: String

Length Constraints: Minimum length of 1. Maximum length of 4096.

Required: No

name

The name of the capacity provider. The name must be unique within your account.

Type: String

Length Constraints: Minimum length of 1. Maximum length of 48.

Pattern: [a-zA-Z][a-zA-Z0-9_]{0,47}

Required: Yes

permissionsConfiguration

The permissions configuration for the capacity provider. This specifies the IAM role that AgentCore uses to manage the Amazon EC2 instances on your behalf.

Type: PermissionsConfiguration object

Required: Yes

tags

A map of tag keys and values to associate with the capacity provider. If you do not specify tags, the capacity provider is created with no tags.

Type: String to string map

Map Entries: Minimum number of 0 items. Maximum number of 50 items.

Key Length Constraints: Minimum length of 1. Maximum length of 128.

Key Pattern: [a-zA-Z0-9\s._:/=+@-]*

Value Length Constraints: Minimum length of 0. Maximum length of 256.

Value Pattern: [a-zA-Z0-9\s._:/=+@-]*

Required: No

Response Syntax

HTTP/1.1 202 Content-type: application/json { "capacityProviderArn": "string", "capacityProviderId": "string", "name": "string", "status": "string" }

Response Elements

If the action is successful, the service sends back an HTTP 202 response.

The following data is returned in JSON format by the service.

capacityProviderArn

The Amazon Resource Name (ARN) of the capacity provider.

Type: String

Pattern: arn:aws(-[^:]+)?:bedrock-agentcore:[a-z0-9-]+:[0-9]{12}:capacity-provider/[a-zA-Z][a-zA-Z0-9_]{0,47}-[a-zA-Z0-9]{10}

capacityProviderId

The unique identifier of the created capacity provider.

Type: String

Length Constraints: Minimum length of 12. Maximum length of 59.

Pattern: [a-zA-Z][a-zA-Z0-9_]{0,47}-[a-zA-Z0-9]{10}

name

The name of the capacity provider.

Type: String

Length Constraints: Minimum length of 1. Maximum length of 48.

Pattern: [a-zA-Z][a-zA-Z0-9_]{0,47}

status

The current status of the capacity provider. For possible values, see CapacityProviderStatus.

Type: String

Valid Values: CREATING | CREATE_FAILED | UPDATING | UPDATE_FAILED | READY | DELETING | DELETE_FAILED

Errors

For information about the errors that are common to all actions, see Common Error Types.

AccessDeniedException

This exception is thrown when a request is denied per access permissions

HTTP Status Code: 403

ConflictException

This exception is thrown when there is a conflict performing an operation

HTTP Status Code: 409

InternalServerException

This exception is thrown if there was an unexpected error during processing of request

HTTP Status Code: 500

ResourceNotFoundException

This exception is thrown when a resource referenced by the operation does not exist

HTTP Status Code: 404

RetryableConflictException

The operation failed because of a conflicting request. Retry the request.

HTTP Status Code: 409

ServiceQuotaExceededException

This exception is thrown when a request is made beyond the service quota

HTTP Status Code: 402

ThrottlingException

This exception is thrown when the number of requests exceeds the limit

HTTP Status Code: 429

ValidationException

The input fails to satisfy the constraints specified by the service.

HTTP Status Code: 400

See Also

For more information about using this API in one of the language-specific AWS SDKs, see the following: